#!/bin/sh

PROTOTYPE="No"
BODY="No"

while echo x"$1" | grep "^x-" > /dev/null
do
  if [ x"$1" = x"-p" ]
  then
    PROTOTYPE="Yes"
  else
    if [ x"$1" = x"-b" ]
    then
      BODY="Yes"
    fi
  fi
  shift
done

OBJ="$1"

if [ x"$OBJ" = x"" ]
then
  OBJ="YOUR_TYPE_HERE"
fi

if [ x"$PROTOTYPE" = x"Yes" ]
then
  echo "function GTK_IS_""$OBJ"" (Obj : Pointer) : Boolean;"
  echo "function GTK_IS_""$OBJ""_CLASS (Klass : Pointer) : Boolean;"
fi

if [ x"$BODY" = x"Yes" ]
then
  echo "function GTK_IS_""$OBJ"" (Obj : Pointer) : Boolean;"
  echo "begin"
  echo "  GTK_IS_""$OBJ"" := (Obj <> nil) and GTK_IS_""$OBJ""_CLASS(PGtkTypeObject(Obj)^.Klass);"
  echo "end;"
  echo
  echo "function GTK_IS_""$OBJ""_CLASS (Klass : Pointer) : Boolean;"
  echo "begin"
  echo "  GTK_IS_""$OBJ""_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_""$OBJ"") <> G_FALSE);"
  echo "end;"
fi
