{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program FileSel;

{$include "../units/gtk.inc"}
{$ignore-function-results}

{ Get the selected filename and print it to the console }
procedure FileOkSel(W : PGtkWidget; FS : PGtkFileSelection);
begin
  Writeln(CString2String(GtkFileSelectionGetFileName(FS)));
end;

procedure Destroy(Widget : PGtkWidget; Data : GPointer);
begin
  GtkMainQuit;
end;

var
  FileW : PGtkWidget;

begin
  GtkInit;

  FileW := GtkFileSelectionNew('File selection');
  GtkSignalConnect(PGtkObject(FileW), 'destroy', @Destroy, FileW);
  { Connect the ok_button to file_ok_sel function }
  GtkSignalConnect(PGtkObject(PGtkFileSelection(FileW)^.OkButton), 'clicked', @FileOkSel, FileW);

  { Connect the cancel_button to destroy the widget }
  GtkSignalConnectObject(PGtkObject(PGtkFileSelection(FileW)^.CancelButton), 'clicked', @GtkWidgetDestroy, PGtkObject(FileW));

  { Lets set the filename, as if this were a save dialog, and we are giving
    a default filename }
  GtkFileSelectionSetFilename(PGtkFileSelection(FileW), 'penguin.png');
  GtkWidgetShow(FileW);
  GtkMain;
end.
