{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GDK - The GIMP Drawing Kit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

{ Includes gdktypes.h and gdkcursors.h }

Unit GdkTypes;
Interface
  Uses
    GLib;

Const
  GDK_NONE = 0;
  GDK_CURRENT_TIME = 0;
  GDK_PARENT_RELATIVE =1;
  
  { GdkWindowType }
  GDK_WINDOW_ROOT = 0;
  GDK_WINDOW_TOPLEVEL =1;
  GDK_WINDOW_CHILD =2;
  GDK_WINDOW_DIALOG = 3;
  GDK_WINDOW_TEMP =4;
  GDK_WINDOW_PIXMAP =5;
  GDK_WINDOW_FOREIGN =6;

  { GdkWindowClass }
  GDK_INPUT_OUTPUT =0;
  GDK_INPUT_ONLY =1;

  { GdkImageType }
  GDK_IMAGE_NORMAL =0;
  GDK_IMAGE_SHARED =1;
  GDK_IMAGE_FASTEST =2;

  { GdkVisualType }
  GDK_VISUAL_STATIC_GRAY = 0;
  GDK_VISUAL_GRAYSCALE =1;
  GDK_VISUAL_STATIC_COLOR =2;
  GDK_VISUAL_PSEUDO_COLOR =3;
  GDK_VISUAL_TRUE_COLOR =4;
  GDK_VISUAL_DIRECT_COLOR =5;

  { GdkFontType }
  GDK_FONT_FONT = 0;
  GDK_FONT_FONTSET =1;

  { GdkWindowAttributesType }
  GDK_WA_TITLE    = 2;
  GDK_WA_X        = 4;
  GDK_WA_Y        = 8;
  GDK_WA_CURSOR   = 16;
  GDK_WA_COLORMAP = 32;
  GDK_WA_VISUAL   = 64;
  GDK_WA_WMCLASS  = 128;
  GDK_WA_NOREDIR  = 256;

  { GdkWindowHints }
  GDK_HINT_POS        = 1;
  GDK_HINT_MIN_SIZE   = 2;
  GDK_HINT_MAX_SIZE   = 4;
  GDK_HINT_BASE_SIZE  = 8;
  GDK_HINT_ASPECT     = 16;
  GDK_HINT_RESIZE_INC = 32;

  { GdkFunction }
  GDK_COPY =0;
  GDK_INVERT =1;
  GDK_XOR =2;
  GDK_CLEAR =3;
  GDK_AND =4;
  GDK_AND_REVERSE =5;
  GDK_AND_INVERT = 6;
  GDK_NOOP =7;
  GDK_OR =8;
  GDK_EQUIV =9;
  GDK_OR_REVERSE =10;
  GDK_COPY_INVERT=11;
  GDK_OR_INVERT =12;
  GDK_NAND = 13;
  GDK_SET =14;

  { GdkFill }
  GDK_SOLID =0;
  GDK_TILED =1;
  GDK_STIPPLED =2;
  GDK_OPAQUE_STIPPLED =3;

  { GdkFillRule }
  GDK_EVEN_ODD_RULE=0;
  GDK_WINDING_RULE=1;

  { GdkLineStyle }
  GDK_LINE_SOLID = 0 ;
  GDK_LINE_ON_OFF_DASH =1;
  GDK_LINE_DOUBLE_DASH =2;

  { GdkCapStyle }
  GDK_CAP_NOT_LAST = 0;
  GDK_CAP_BUTT =1;
  GDK_CAP_ROUND =2;
  GDK_CAP_PROJECTING =3;

  { GdkJoinStyle }
  GDK_JOIN_MITER = 0;
  GDK_JOIN_ROUND =1;
  GDK_JOIN_BEVEL =2;

  { GdkCursorType }
  GDK_NUM_GLYPHS = 154;
  GDK_X_CURSOR = 0;
  GDK_ARROW = 2;
  GDK_BASED_ARROW_DOWN = 4;
  GDK_BASED_ARROW_UP = 6;
  GDK_BOAT = 8;
  GDK_BOGOSITY = 10;
  GDK_BOTTOM_LEFT_CORNER = 12;
  GDK_BOTTOM_RIGHT_CORNER = 14;
  GDK_BOTTOM_SIDE = 16;
  GDK_BOTTOM_TEE = 18;
  GDK_BOX_SPIRAL = 20;
  GDK_CENTER_PTR = 22;
  GDK_CIRCLE = 24;
  GDK_CLOCK = 26;
  GDK_COFFEE_MUG = 28;
  GDK_CROSS = 30;
  GDK_CROSS_REVERSE = 32;
  GDK_CROSSHAIR = 34;
  GDK_DIAMOND_CROSS = 36;
  GDK_DOT = 38;
  GDK_DOTBOX = 40;
  GDK_DOUBLE_ARROW = 42;
  GDK_DRAFT_LARGE = 44;
  GDK_DRAFT_SMALL = 46;
  GDK_DRAPED_BOX = 48;
  GDK_EXCHANGE = 50;
  GDK_FLEUR = 52;
  GDK_GOBBLER = 54;
  GDK_GUMBY = 56; 
  GDK_HAND1 = 58;
  GDK_HAND2 = 60;
  GDK_HEART = 62;
  GDK_ICON = 64;
  GDK_IRON_CROSS = 66;
  GDK_LEFT_PTR = 68;
  GDK_LEFT_SIDE = 70; 
  GDK_LEFT_TEE = 72;
  GDK_LEFTBUTTON = 74;
  GDK_LL_ANGLE = 76;
  GDK_LR_ANGLE = 78;
  GDK_MAN = 80;
  GDK_MIDDLEBUTTON = 82;
  GDK_MOUSE = 84;
  GDK_PENCIL = 86;
  GDK_PIRATE = 88;
  GDK_PLUS = 90;
  GDK_QUESTION_ARROW = 92;
  GDK_RIGHT_PTR = 94;
  GDK_RIGHT_SIDE = 96;
  GDK_RIGHT_TEE = 98;
  GDK_RIGHTBUTTON = 100;
  GDK_RTL_LOGO = 102;
  GDK_SAILBOAT = 104;
  GDK_SB_DOWN_ARROW = 106;
  GDK_SB_H_DOUBLE_ARROW = 108;
  GDK_SB_LEFT_ARROW = 110;
  GDK_SB_RIGHT_ARROW = 112;
  GDK_SB_UP_ARROW = 114;
  GDK_SB_V_DOUBLE_ARROW = 116;
  GDK_SHUTTLE = 118;
  GDK_SIZING = 120;
  GDK_SPIDER = 122;
  GDK_SPRAYCAN = 124;
  GDK_STAR = 126;
  GDK_TARGET = 128;
  GDK_TCROSS = 130;
  GDK_TOP_LEFT_ARROW = 132;
  GDK_TOP_LEFT_CORNER = 134;
  GDK_TOP_RIGHT_CORNER = 136;
  GDK_TOP_SIDE = 138;
  GDK_TOP_TEE = 140;
  GDK_TREK = 142;
  GDK_UL_ANGLE = 144;
  GDK_UMBRELLA = 146;
  GDK_UR_ANGLE = 148;
  GDK_WATCH = 150;
  GDK_XTERM = 152;
  GDK_LAST_CURSOR=GDK_XTERM;
  GDK_CURSOR_IS_PIXMAP = -1;

  { GdkFilterReturn }
  GDK_FILTER_CONTINUE=0;
  GDK_FILTER_TRANSLATE=1;
  GDK_FILTER_REMOVE=2;

  { GdkVisibilityState }
  GDK_VISIBILITY_UNOBSCURED =0;
  GDK_VISIBILITY_PARTIAL = 1;
  GDK_VISIBILITY_FULLY_OBSCURED =2;

  { GdkEventType }
  GDK_NOTHING           = -1;
  GDK_DELETE            = 0;
  GDK_DESTROY           = 1;
  GDK_EXPOSE            = 2;
  GDK_MOTION_NOTIFY     = 3;
  GDK_BUTTON_PRESS      = 4;
  GDK_2BUTTON_PRESS     = 5;
  GDK_3BUTTON_PRESS     = 6;
  GDK_BUTTON_RELEASE    = 7;
  GDK_KEY_PRESS         = 8;
  GDK_KEY_RELEASE       = 9;
  GDK_ENTER_NOTIFY      = 10;
  GDK_LEAVE_NOTIFY      = 11;
  GDK_FOCUS_CHANGE      = 12;
  GDK_CONFIGURE         = 13;
  GDK_MAP               = 14;
  GDK_UNMAP             = 15;
  GDK_PROPERTY_NOTIFY   = 16;
  GDK_SELECTION_CLEAR   = 17;
  GDK_SELECTION_REQUEST = 18;
  GDK_SELECTION_NOTIFY  = 19;
  GDK_PROXIMITY_IN      = 20;
  GDK_PROXIMITY_OUT     = 21;
  GDK_DRAG_ENTER        = 22;
  GDK_DRAG_LEAVE        = 23;
  GDK_DRAG_MOTION       = 24;
  GDK_DRAG_STATUS       = 25;
  GDK_DROP_START        = 26;
  GDK_DROP_FINISHED     = 27;
  GDK_CLIENT_EVENT      = 28;
  GDK_VISIBILITY_NOTIFY = 29;
  GDK_NO_EXPOSE         = 30;

  { GdkEventMask }
  GDK_EXPOSURE_MASK             = 1 shl 1;
  GDK_POINTER_MOTION_MASK       = 1 shl 2;
  GDK_POINTER_MOTION_HINT_MASK  = 1 shl 3;
  GDK_BUTTON_MOTION_MASK        = 1 shl 4;
  GDK_BUTTON1_MOTION_MASK       = 1 shl 5;
  GDK_BUTTON2_MOTION_MASK       = 1 shl 6;
  GDK_BUTTON3_MOTION_MASK       = 1 shl 7;
  GDK_BUTTON_PRESS_MASK         = 1 shl 8;
  GDK_BUTTON_RELEASE_MASK       = 1 shl 9;
  GDK_KEY_PRESS_MASK            = 1 shl 10;
  GDK_KEY_RELEASE_MASK          = 1 shl 11;
  GDK_ENTER_NOTIFY_MASK         = 1 shl 12;
  GDK_LEAVE_NOTIFY_MASK         = 1 shl 13;
  GDK_FOCUS_CHANGE_MASK         = 1 shl 14;
  GDK_STRUCTURE_MASK            = 1 shl 15;
  GDK_PROPERTY_CHANGE_MASK      = 1 shl 16;
  GDK_VISIBILITY_NOTIFY_MASK    = 1 shl 17;
  GDK_PROXIMITY_IN_MASK         = 1 shl 18;
  GDK_PROXIMITY_OUT_MASK        = 1 shl 19;
  GDK_SUBSTRUCTURE_MASK         = 1 shl 20;
  GDK_ALL_EVENTS_MASK           = 16#0FFFFF;

  { GdkNotifyType }
  GDK_NOTIFY_ANCESTOR           = 0;
  GDK_NOTIFY_VIRTUAL            = 1;
  GDK_NOTIFY_INFERIOR           = 2;
  GDK_NOTIFY_NONLINEAR          = 3;
  GDK_NOTIFY_NONLINEAR_VIRTUAL  = 4;
  GDK_NOTIFY_UNKNOWN            = 5;
  
  { GdkCrossingMode }
  GDK_CROSSING_NORMAL=0;
  GDK_CROSSING_GRAB =1;
  GDK_CROSSING_UNGRAB=2;

  { GdkModifierType }
  GDK_SHIFT_MASK    = 1 shl 0;
  GDK_LOCK_MASK     = 1 shl 1;
  GDK_CONTROL_MASK  = 1 shl 2;
  GDK_MOD1_MASK     = 1 shl 3;
  GDK_MOD2_MASK     = 1 shl 4;
  GDK_MOD3_MASK     = 1 shl 5;
  GDK_MOD4_MASK     = 1 shl 6;
  GDK_MOD5_MASK     = 1 shl 7;
  GDK_BUTTON1_MASK  = 1 shl 8;
  GDK_BUTTON2_MASK  = 1 shl 9;
  GDK_BUTTON3_MASK  = 1 shl 10;
  GDK_BUTTON4_MASK  = 1 shl 11;
  GDK_BUTTON5_MASK  = 1 shl 12;
  GDK_RELEASE_MASK  = 1 shl 13;
  GDK_MODIFIER_MASK = 16#3fff;

  { GdkSubwindowMode }
  GDK_CLIP_BY_CHILDREN  = 0;
  GDK_INCLUDE_INFERIORS = 1;

  { GdkInputCondition }
  GDK_INPUT_READ       = 1 shl 0;
  GDK_INPUT_WRITE      = 1 shl 1;
  GDK_INPUT_EXCEPTION  = 1 shl 2;

  { GdkStatus }
  GDK_OK          = 0;
  GDK_ERROR       = -1;
  GDK_ERROR_PARAM = -2;
  GDK_ERROR_FILE  = -3;
  GDK_ERROR_MEM   = -4;

  { GdkByteOrder }
  GDK_LSB_FIRST=0;
  GDK_MSB_FIRST=1;

  { GdkGCValuesMask }
  GDK_GC_FOREGROUND    = 1 shl 0;
  GDK_GC_BACKGROUND    = 1 shl 1;
  GDK_GC_FONT          = 1 shl 2;
  GDK_GC_FUNCTION      = 1 shl 3;
  GDK_GC_FILL          = 1 shl 4;
  GDK_GC_TILE          = 1 shl 5;
  GDK_GC_STIPPLE       = 1 shl 6;
  GDK_GC_CLIP_MASK     = 1 shl 7;
  GDK_GC_SUBWINDOW     = 1 shl 8;
  GDK_GC_TS_X_ORIGIN   = 1 shl 9;
  GDK_GC_TS_Y_ORIGIN   = 1 shl 10;
  GDK_GC_CLIP_X_ORIGIN = 1 shl 11;
  GDK_GC_CLIP_Y_ORIGIN = 1 shl 12;
  GDK_GC_EXPOSURES     = 1 shl 13;
  GDK_GC_LINE_WIDTH    = 1 shl 14;
  GDK_GC_LINE_STYLE    = 1 shl 15;
  GDK_GC_CAP_STYLE     = 1 shl 16;
  GDK_GC_JOIN_STYLE    = 1 shl 17;

  { GdkSelection }
  GDK_SELECTION_PRIMARY = 1;
  GDK_SELECTION_SECONDARY = 2;

  { GdkPropertyState }
  GDK_PROPERTY_NEW_VALUE=0;
  GDK_PROPERTY_DELETE=1;
  
  { GdkPropMode }
  GDK_PROP_MODE_REPLACE=0;
  GDK_PROP_MODE_PREPEND=1;
  GDK_PROP_MODE_APPEND=2;

  { GdkInputSource }
  GDK_SOURCE_MOUSE=0;
  GDK_SOURCE_PEN=1;
  GDK_SOURCE_ERASER=2;
  GDK_SOURCE_CURSOR=3;

  { GdkInputMode }
  GDK_MODE_DISABLED=0;
  GDK_MODE_SCREEN=1;
  GDK_MODE_WINDOW=2;

  { GdkAxisUse }
  GDK_AXIS_IGNORE=0;
  GDK_AXIS_X=1;
  GDK_AXIS_Y=2;
  GDK_AXIS_PRESSURE=3;
  GDK_AXIS_XTILT=4;
  GDK_AXIS_YTILT=5;
  GDK_AXIS_LAST=6;

  { GdkTarget }
  GDK_TARGET_BITMAP = 5;
  GDK_TARGET_COLORMAP = 7;
  GDK_TARGET_DRAWABLE = 17;
  GDK_TARGET_PIXMAP = 20;
  GDK_TARGET_STRING = 31;

  { GdkSelectionType }
  GDK_SELECTION_TYPE_ATOM = 4;
  GDK_SELECTION_TYPE_BITMAP = 5;
  GDK_SELECTION_TYPE_COLORMAP = 7;
  GDK_SELECTION_TYPE_DRAWABLE = 17;
  GDK_SELECTION_TYPE_INTEGER = 19;
  GDK_SELECTION_TYPE_PIXMAP = 20;
  GDK_SELECTION_TYPE_WINDOW = 33;
  GDK_SELECTION_TYPE_STRING = 31;

  { GdkExtensionMode }
  GDK_EXTENSION_EVENTS_NONE=0;
  GDK_EXTENSION_EVENTS_ALL=1;
  GDK_EXTENSION_EVENTS_CURSOR=2;

  { GdkIMStyle }
  GDK_IM_PREEDIT_AREA      = 16#0001; 
  GDK_IM_PREEDIT_CALLBACKS = 16#0002; 
  GDK_IM_PREEDIT_POSITION  = 16#0004;
  GDK_IM_PREEDIT_NOTHING   = 16#0008;
  GDK_IM_PREEDIT_NONE      = 16#0010;
  GDK_IM_PREEDIT_MASK      = 16#001f;
  GDK_IM_STATUS_AREA       = 16#0100; 
  GDK_IM_STATUS_CALLBACKS  = 16#0200;
  GDK_IM_STATUS_NOTHING    = 16#0400;
  GDK_IM_STATUS_NONE       = 16#0800;
  GDK_IM_STATUS_MASK       = 16#0f00;

  { GdkICAttributesType }
  GDK_IC_STYLE                  = 1 shl 0;
  GDK_IC_CLIENT_WINDOW          = 1 shl 1;
  GDK_IC_FOCUS_WINDOW           = 1 shl 2;
  GDK_IC_FILTER_EVENTS          = 1 shl 3;
  GDK_IC_SPOT_LOCATION          = 1 shl 4;
  GDK_IC_LINE_SPACING           = 1 shl 5;
  GDK_IC_CURSOR                 = 1 shl 6;
  GDK_IC_PREEDIT_FONTSET        = 1 shl 10;
  GDK_IC_PREEDIT_AREA           = 1 shl 11;
  GDK_IC_PREEDIT_AREA_NEEDED    = 1 shl 12;
  GDK_IC_PREEDIT_FOREGROUND     = 1 shl 13;
  GDK_IC_PREEDIT_BACKGROUND     = 1 shl 14;
  GDK_IC_PREEDIT_PIXMAP         = 1 shl 15;
  GDK_IC_PREEDIT_COLORMAP       = 1 shl 16;
  GDK_IC_STATUS_FONTSET         = 1 shl 21;
  GDK_IC_STATUS_AREA            = 1 shl 22;
  GDK_IC_STATUS_AREA_NEEDED     = 1 shl 23;
  GDK_IC_STATUS_FOREGROUND      = 1 shl 24;
  GDK_IC_STATUS_BACKGROUND      = 1 shl 25;
  GDK_IC_STATUS_PIXMAP          = 1 shl 26;
  GDK_IC_STATUS_COLORMAP        = 1 shl 27;
  GDK_IC_ALL_REQ                = GDK_IC_STYLE Or GDK_IC_CLIENT_WINDOW;
  GDK_IC_PREEDIT_AREA_REQ       = GDK_IC_PREEDIT_AREA Or GDK_IC_PREEDIT_FONTSET;
  GDK_IC_PREEDIT_POSITION_REQ   = GDK_IC_PREEDIT_AREA Or GDK_IC_SPOT_LOCATION
                                                    Or GDK_IC_PREEDIT_FONTSET;
  GDK_IC_STATUS_AREA_REQ        = GDK_IC_STATUS_AREA Or GDK_IC_STATUS_FONTSET;

  { GdkWMDecoration }
  GDK_DECOR_ALL         = 1 shl 0;
  GDK_DECOR_BORDER      = 1 shl 1;
  GDK_DECOR_RESIZEH     = 1 shl 2;
  GDK_DECOR_TITLE       = 1 shl 3;
  GDK_DECOR_MENU        = 1 shl 4;
  GDK_DECOR_MINIMIZE    = 1 shl 5;
  GDK_DECOR_MAXIMIZE    = 1 shl 6;

  { GdkWMFunction }
  GDK_FUNC_ALL          = 1 shl 0;
  GDK_FUNC_RESIZE       = 1 shl 1;
  GDK_FUNC_MOVE         = 1 shl 2;
  GDK_FUNC_MINIMIZE     = 1 shl 3;
  GDK_FUNC_MAXIMIZE     = 1 shl 4;
  GDK_FUNC_CLOSE        = 1 shl 5;

  { GdkColorContextMode }
  GDK_CC_MODE_UNDEFINED=0;
  GDK_CC_MODE_BW=1;
  GDK_CC_MODE_STD_CMAP=2;
  GDK_CC_MODE_TRUE=3;
  GDK_CC_MODE_MY_GRAY=4;
  GDK_CC_MODE_PALETTE=5;

  { GdkOverlapType }
  GDK_OVERLAP_RECTANGLE_IN=0;
  GDK_OVERLAP_RECTANGLE_OUT=1;
  GDK_OVERLAP_RECTANGLE_PART=2;
  
  { GdkDragAction }
  GDK_ACTION_DEFAULT = 1 shl 0;
  GDK_ACTION_COPY    = 1 shl 1;
  GDK_ACTION_MOVE    = 1 shl 2;
  GDK_ACTION_LINK    = 1 shl 3;
  GDK_ACTION_PRIVATE = 1 shl 4;
  GDK_ACTION_ASK     = 1 shl 5;

  { GdkDragProtocol }
  GDK_DRAG_PROTO_MOTIF=0;
  GDK_DRAG_PROTO_XDND=1;
  GDK_DRAG_PROTO_ROOTWIN=2;
  GDK_DRAG_PROTO_NONE=3;




Type
    
  { End Misc }
  PGdkAtom = ^GdkAtom;
  GdkAtom = gulong;
  PGdkWChar = ^GdkWChar;
  GdkWChar = guint32;
  
  { Enums in C, see constants above }
  GdkWindowType = Integer;
  GdkWindowClass = Integer;
  GdkImageType = Integer;
  PPGdkVisualType = ^PGdkVisualType;
  PGdkVisualType = ^GdkVisualType;
  GdkVisualType = Integer;
  GdkFontType = Integer;
  GdkWindowAttributesType = Integer;
  GdkWindowHints = Integer;
  GdkFunction = Integer;
  GdkFill = Integer;
  GdkFillRule = Integer;
  GdkLineStyle = Integer;
  GdkCapStyle = Integer;
  GdkJoinStyle = Integer;
  GdkCursorType = Integer;
  GdkFilterReturn = Integer;
  GdkVisibilityState = Integer;
  GdkEventType = Integer;
  GdkEventMask = Integer;
  GdkNotifyType = Integer;
  GdkCrossingMode = Integer;
  PGdkModifierType =^GdkModifierType;
  GdkModifierType = Integer;
  GdkSubwindowMode = Integer;
  GdkInputCondition = Integer;
  GdkStatus = Integer;
  GdkByteOrder = Integer;
  GdkGCValuesMask = Integer;
  GdkSelection = Integer;
  GdkPropertyState = Integer;
  GdkPropMode   = Integer;
  GdkInputSource = Integer;
  GdkInputMode   = Integer;
  PGdkAxisUse = ^GdkAxisUse;
  GdkAxisUse = Integer;
  GdkTarget = Integer;
  GdkSelectionType   = Integer;
  GdkExtensionMode = Integer;
  GdkIMStyle = Integer;
  GdkICAttributesType = Integer;
  GdkWMDecoration = Integer;
  GdkWMFunction = Integer;
  GdkColorContextMode = Integer;
  GdkOverlapType = Integer;
  GdkDragAction = Integer;
  PGdkDragProtocol = ^GdkDragProtocol;
  GdkDragProtocol = Integer;

  PGdkXEvent = Pointer;
  PGdkIC     = Pointer;


  
  PGdkcolor = ^GdkColor;
  GdkColor = Record 
    pixel : gulong;
    red   : gushort;
    green : gushort;
    blue  : gushort;
  End;
  
  PPGdkColormap=^PGdkColormap;
  PGdkColormap = ^GdkColormap;
  GdkColormap = Record
    size: gint;
    colors : PGdkColor
  End;    

  PGdkFont = ^GdkFont;
  GdkFont = Record
    TType : GdkFontType;
    Ascent, Descent : gint;
  End;


  
  PGdkVisual = ^GdkVisual;
  GdkVisual = Record
    TType : GdkVisualType;
    Depth : gint;
    ByteOrder : GdkByteOrder;
    ColormapSize: gint;
    BitsPerRGB:gint;

    RedMask:guint32 ;
    RedShift:gint ;
    RedPrec:gint ;

    GreenMask:guint32 ;
    GreenShift : gint;
    GreenPrec : gint ;

    BlueMask:guint32 ;
    BlueShift : gint;
    BluePrec : gint ;
  End;
  
  PGdkCursor = ^GdkCursor;
  GdkCursor  = Record
    TType : GdkCursorType;
  End;

  
  PGdkWindowAttr=^GdkWindowAttr;
  GdkWindowAttr = Record
    title : PGChar;
    eventMask:gint ;
    x, y:gint16;
    width:gint16;
    height:gint16;
    wclass:GdkWindowClass;
    visual:PGdkVisual;
    colormap:PGdkColormap;
    windowType:GdkWindowType;
    cursor:PGdkCursor;
    wmclassName : PGChar;
    wmclassClass : PGChar;
    overrideRedirect: gboolean;
  End;
  
  PGdkWindow = ^GdkWindow;
  PPGdkWindow=^PGdkWindow;
  GdkWindow  = Record
    userData : gpointer;
  End;
  
  PGdkPixmap = ^GdkPixmap;
  GdkPixmap = GdkWindow;
  
  PPGdkBitmap = ^PGdkBitmap;
  PGdkBitmap = ^GdkBitmap;
  GdkBitmap = GdkWindow;

  PGdkDrawable = ^GdkDrawable;
  GdkDrawable = GdkWindow;

  PGdkGeometry = ^GdkGeometry;
  GdkGeometry = Record
    minWidth : gint;
    minHeight : gint;
    maxWidth : gint;
    maxHeight : gint;
    baseWidth : gint;
    baseHeight : gint;
    widthInc : gint;
    heightInc : gint;
    minAspect : gdouble;
    maxAspect : gdouble;
  End;
  
  PGdkImage = ^GdkImage;
  GdkImage = Record
    TType : GdkImageType;
    visual : PGdkVisual;
    byteOrder : GdkByteOrder   ;
    width: guint16;
    height: guint16;
    depth: guint16;
    bpp: guint16;
    bpl: guint16;
    mem : gpointer;
  End;

  PGdkGCValues = ^GdkGCValues;
  GdkGCValues = Record
    foreground : GdkColor;
    background : GdkColor;
    font : PGdkFont;
    func : GdkFunction;
    fill : GdkFill;
    tile : PGdkPixmap;
    stipple: PGdkPixmap;
    clipMask : PGdkPixmap;
    subwindowMode : GdkSubwindowMode;
    tsXOrigin: gint;
    tsYOrigin: gint;
    clipXOrigin: gint;
    clipYOrigin: gint;
    graphicsExposures: gint;
    lineWidth: gint;
    lineStyle : GdkLineStyle;
    capStyle : GdkCapStyle;
    joinStyle : GdkJoinStyle;
  End;
  
  PGdkGC = ^GdkGC;
  GdkGC = Record
    dummyVar : gint;
  End;
  
  PGdkPoint = ^GdkPoint;
  GdkPoint = Record
    x, y : gint16;
  End;
  
  PGdkRectangle = ^GdkRectangle;
  GdkRectangle  = Record
    x, y : gint16;  
    width, height : guint16;
  End;

  PGdkSegment = ^GdkSegment;
  GdkSegment  = Record
    x1, y1, x2, y2 : gint16;
  End;
  

  GdkColorContextDitherFrame1 = Array [0..31, 0..31, 0..31] Of gint;
  PGdkColorContextDither = ^GdkColorContextDither;
  GdkColorContextDither  = Record 
    fastRgb, fastErr : GdkColorContextDitherFrame1;
    fastErg, fastErb : GdkColorContextDitherFrame1;
  End;
  
  
  GdkColorContextFrame1=Record red, green, blue : gint;   End;
  GdkColorContextFrame2=Record red, green, blue : gulong; End;
    
  PGdkColorContext = ^GdkColorContext;
  GdkColorContext  = Record
    Visual : PGdkVisual;
    Colormap : PGdkColormap;

    NumColors : gint;
    MaxColors : gint;
    NumAllocated : gint;

    Mode : GdkColorContextMode;
    NeedToFreeColormap : gint;
    stdCmapAtom : GdkAtom;
    clut : Pgulong;
    cmap : PGdkColor;
    colorHash : PGHashTable;
    palette : PGdkColor;
    numPalette : gint;
    fastDither : PGdkColorContextDither;
    shifts  : GdkColorContextFrame1;
    masks   : GdkColorContextFrame2;
    bits    : GdkColorContextFrame1;
    maxEntry, blackPixel, whitePixel : gulong;
  End;

  PGdkDeviceKey = ^GdkDeviceKey;
  GdkDeviceKey = Record
    keyval : guint;
    modifiers : GdkModifierType;
  End;
  
  PGdkDeviceInfo = ^GdkDeviceInfo;
  GdkDeviceInfo = Record
    deviceid : guint32;
    name : PGChar;
    source : GdkInputSource;
    mode : GdkInputMode;
    hasCursor, numAxes : gint;
    axes : PGdkAxisUse;
    numKeys : gint;
    keys : PGdkDeviceKey;
  End;

  PGdkTimeCoord = ^GdkTimeCoord;
  GdkTimeCoord  = Record
    time : guint32;
    x, y, pressure, xtilt, ytilt : gdouble;
  End;
  
  PGdkDragContext = ^GdkDragContext;
  GdkDragContext  = Record
    protocol : GdkDragProtocol;
    isSource : gboolean;
    sourceWindow : PGdkWindow;
    destWindow : PGdkWindow;
    targets : PGList;
    actions : GdkDragAction;
    suggestedAction : GdkDragAction;
    action : GdkDragAction; 
    startTime : guint32;
  End;



  GdkInputFunction=^Procedure(data : gpointer; source: gint;
                              condition : GdkInputCondition);
  GdkDestroyNotify=^Procedure(data : gpointer);

  PGdkEventAny = ^GdkEventAny;
  GdkEventAny  = Record
    TType : GdkEventType;
    window : GdkWindow;
    sendEvent : gint8;
  End;
  
  PGdkEventExpose = ^GdkEventExpose;
  GdkEventExpose  = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    area : GdkRectangle;
    count : gint;
  End;

  PGdkEventNoExpose = ^GdkEventNoExpose;
  GdkEventNoExpose  = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
  End;
  
  PGdkEventVisibility = ^GdkEventVisibility;
  GdkEventVisibility  = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    state : GdkVisibilityState;
  End;

  PGdkEventMotion = ^GdkEventMotion;
  GdkEventMotion  = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    time : guint32;
    x, y : gdouble;
    pressure, xtilt, ytilt : gdouble;
    state : guint;
    isHint : gint16;
    source : GdkInputSource;
    deviceid : guint32;
    xRoot, yRoot : gdouble;
  End;  

  PGdkEventButton = ^GdkEventButton;
  GdkEventButton  = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    time : guint32;
    x, y : gdouble;
    pressure, xtilt, ytilt : gdouble;
    state : guint;
    button : guint;
    source : GdkInputSource;
    deviceid : guint32;
    xRoot, yRoot : gdouble;
  End;

  PGdkEventKey = ^GdkEventKey;
  GdkEventKey = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    time : guint32;
    state : guint;
    keyval : guint;
    length : gint;
    s : PGChar;
  End;

  PGdkEventCrossing = ^GdkEventCrossing;
  GdkEventCrossing  = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    subwindow : GdkWindow;
    time : guint32;
    x, y : gdouble;
    xRoot, yRoot : gdouble;
    mode : GdkCrossingMode;
    detail : GdkNotifyType;
    focus : gboolean;
    state : guint;
  End;

  PGdkEventFocus = ^GdkEventFocus;
  GdkEventFocus  = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    i : gint16;
  End;

  PGdkEventConfigure = ^GdkEventConfigure;
  GdkEventConfigure  = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    e, y, width, height : gint16;
  End;

  PGdkEventProperty = ^GdkEventProperty;
  GdkEventProperty  = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    atom : GdkAtom;
    time : guint32;
    state : guint;
  End;

  PGdkEventSelection = ^GdkEventSelection;
  GdkEventSelection  = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    selection, trgt, prprty : GdkAtom;
    requestor, time : guint32;
  End;

  PGdkEventProximity = ^GdkEventProximity;
  GdkEventProximity  = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    time : guint32;
    source : GdkInputSource;
    deviceid : guint32;
  End;

  PGdkEventClient = ^GdkEventClient;
  GdkEventClient  = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    messageType : GdkAtom;
    dataFormat : gushort;
    case Byte of
      0: (b : Array [0..19] Of Integer(1));
      1: (s : Array [0..9] Of Integer(2));
      2: (l : Array [0..4] Of Integer(4));
  End;

  PGdkEventDND = ^GdkEventDND;
  GdkEventDND = Record
    TType : GdkEventType;
    window : PGdkWindow;
    sendEvent : gint8;
    context : PGdkDragContext;
    time : guint32;
    xRoot, yRoot : gshort;
  End;

  PGdkEvent = ^GdkEvent;
  GdkEvent  = Record
    Case Integer Of
      0:(TType : GdkEventType);
      1:(any : GdkEventAny);
      2:(expose : GdkEventExpose);
      3:(noExpose : GdkEventNoExpose);
      4:(visibility : GdkEventVisibility);
      5:(motion : GdkEventMotion);
      6:(button : GdkEventButton);
      7:(key : GdkEventKey);
      8:(crossing : GdkEventCrossing);
      9:(focusChange : GdkEventFocus);
     10:(configure : GdkEventConfigure);
     11:(prprty : GdkEventProperty);
     12:(selection : GdkEventSelection);
     13:(proximity : GdkEventProximity);
     14:(client : GdkEventClient);
     15:(dnd : GdkEventDND);
  End;    

  GdkFilterFunc = ^Function (xevent : PGdkXEvent; evt : PGdkEvent;
                             data : gpointer) : GdkFilterReturn;

  GdkEventFunc    =^Procedure (event : PGdkEvent; data : gpointer);


  PGdkRegion= ^GdkRegion;
  GdkRegion = Record
    userData : gpointer;
  End;

  PGdkICAttr = ^GdkICAttr;
  GdkICAttr  = Record
    style : GdkIMStyle;
    clientWindow : PGdkWindow;
    focusWindow : PGdkWindow;
    filterWvents : GdkEventMask;
    spotLocation : GdkPoint;
    lineSpacing : gint;
    cursor : PGdkCursor;
    preeditFontset : PGdkFont;
    preeditArea : GdkRectangle;
    preeditAreaNeeded : GdkRectangle; 
    preeditForeground : GdkColor;
    preeditBackground : GdkColor;
    preeditPixmap : PGdkPixmap;
    preeditColormap : PGdkColormap;
    statusFontset : PGdkFont;
    statusArea : GdkRectangle;
    statusAreaNeeded : GdkRectangle; 
    statusForeground : GdkColor;
    statusBackground : GdkColor;
    statusPixmap : PGdkPixmap;
    statusColormap : PGdkColormap;
  End;

Implementation

End.
