
{$gnu-pascal}
{$if __GPC_RELEASE__ < 20010429}
{$error This unit requires GPC release 20010429 or newer.}
{$endif}

{ Glib and Gdk standard units. }
uses
  Glib, GModule, Gdk, GdkTypes;

{ !! 2001/02/11 Gtk+ type size test succeeded. }

{ Gtk+ units not included in the widget hierarchy. }
uses
  GtkAccelGroup,
  GtkArg,
  GtkBindings,
  GtkDND,
  GtkEnums,
  GtkGC,
  GtkInvisible,
  GtkMain,
  GtkMarshal,
  GtkMenuFactory,
  GtkRC,
  GtkSelection,
  GtkSignal,
  GtkStyle,
  GtkThemes,
  GtkTypeUtils;

{ Gtk+ widget hierarchy. }
uses
  GtkObject,
    GtkWidget,
      GtkMisc,
        GtkLabel,
          GtkAccelLabel,
          GtkTipsQuery,
        GtkArrow,
        GtkImage,
        GtkPixmap,
      GtkContainer,
        GtkBin,
          GtkAlignment,
          GtkFrame,
            GtkAspectFrame,
          GtkButton,
            GtkToggleButton,
              GtkCheckButton,
                GtkRadioButton,
            GtkOptionMenu,
          GtkItem,
            GtkMenuItem,
              GtkCheckMenuItem,
                GtkRadioMenuItem,
              GtkTearoffMenuItem,
            GtkListItem,
            GtkTreeItem,
          GtkWindow,
            GtkDialog,
              GtkInputDialog,
            GtkFileSel,
            GtkPlug,
          GtkEventBox,
          GtkHandleBox,
          GtkScrolledWindow,
          GtkViewport,
        GtkBox,
          GtkBBox,
            GtkHBBox,
            GtkVBBox,
          GtkVBox,
            GtkColorSel,
            GtkGamma,
          GtkHBox,
            GtkCombo,
            GtkStatusbar,
        GtkCList,
          GtkCTree,
        GtkFixed,
        GtkNotebook,
          GtkFontSel,
        GtkPaned,
          GtkHPaned,
          GtkVPaned,
        GtkLayout,
        GtkList,
        GtkMenuShell,
          GtkMenuBar,
          GtkMenu,
        GtkPacker,
        GtkSocket,
        GtkTable,
        GtkToolbar,
        GtkTree,
      GtkCalendar,
      GtkDrawingArea,
        GtkCurve,
      GtkEditable,
        GtkEntry,
          GtkSpinButton,
        GtkText,
      GtkRuler,
        GtkHRuler,
        GtkVRuler,
      GtkRange,
        GtkScale,
          GtkHScale,
          GtkVScale,
        GtkScrollbar,
          GtkHScrollbar,
          GtkVScrollbar,
      GtkSeparator,
        GtkHSeparator,
        GtkVSeparator,
      GtkPreview,
      GtkProgress,
        GtkProgressBar,
    GtkData,
      GtkAdjustment,
      GtkTooltips,
    GtkItemFactory;

(* @@ $define'd macros can't be exported from unit to unit. So this
      kludgy way of getting a signal offset goes here. *)

{$define GTK_STRUCT_OFFSET(struct, field) (PtrCard(@struct(0)^.field))}
{$define GTK_SIGNAL_OFFSET GTK_STRUCT_OFFSET}
