{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

{ !! Two adjacent underscores aren't allowed, so I used just one
     underscore all around. }

unit GtkMarshal;

interface

uses Glib, GtkObject;

procedure GtkSignalDefaultMarshaller(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__NONE';

procedure GtkMarshal_BOOL_NONE(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_BOOL__NONE';

procedure GtkMarshal_BOOL_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_BOOL__POINTER';


procedure GtkMarshal_BOOL_POINTER_POINTER_INT_INT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_BOOL__POINTER_POINTER_INT_INT';

procedure GtkMarshal_BOOL_POINTER_INT_INT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_BOOL__POINTER_INT_INT';

procedure GtkMarshal_BOOL_POINTER_INT_INT_UINT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_BOOL__POINTER_INT_INT_INT';

procedure GtkMarshal_BOOL_POINTER_INT_INT_INT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_BOOL__POINTER_INT_INT_INT';

procedure GtkMarshal_BOOL_POINTER_STRING_STRING_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_BOOL__POINTER_POINTER_POINTER_POINTER';

procedure GtkMarshal_BOOL_POINTER_POINTER_POINTER_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_BOOL__POINTER_POINTER_POINTER_POINTER';

procedure GtkMarshal_ENUM_ENUM(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_INT__INT';

procedure GtkMarshal_INT_INT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_INT__INT';

procedure GtkMarshal_INT_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_INT__POINTER';

procedure GtkMarshal_INT_POINTER_CHAR_CHAR(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_INT__POINTER_CHAR_CHAR';

procedure GtkMarshal_NONE_BOOL(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__BOOL';

procedure GtkMarshal_NONE_BOXED(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER';

procedure GtkMarshal_NONE_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER';

procedure GtkMarshal_NONE_C_CALLBACK(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__C_CALLBACK';

procedure GtkMarshal_NONE_C_CALLBACK_C_CALLBACK(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__C_CALLBACK_C_CALLBACK';

procedure GtkMarshal_NONE_ENUM(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT';

procedure GtkMarshal_NONE_INT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT';

procedure GtkMarshal_NONE_ENUM_FLOAT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT_FLOAT';

procedure GtkMarshal_NONE_INT_FLOAT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT_FLOAT';

procedure GtkMarshal_NONE_ENUM_FLOAT_BOOL(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT_FLOAT_BOOL';

procedure GtkMarshal_NONE_INT_FLOAT_BOOL(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT_FLOAT_BOOL';

procedure GtkMarshal_NONE_INT_INT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT_INT';

procedure GtkMarshal_NONE_INT_INT_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT_INT_POINTER';

procedure GtkMarshal_NONE_NONE(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__NONE';

procedure GtkMarshal_NONE_OBJECT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER';

procedure GtkMarshal_NONE_POINTER_INT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_INT';

procedure GtkMarshal_NONE_POINTER_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_POINTER';

procedure GtkMarshal_NONE_POINTER_POINTER_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_POINTER_POINTER';

procedure GtkMarshal_NONE_POINTER_STRING_STRING(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_POINTER_POINTER';

procedure GtkMarshal_NONE_POINTER_UINT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_INT';

procedure GtkMarshal_NONE_POINTER_UINT_ENUM(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_INT_INT';

procedure GtkMarshal_NONE_POINTER_INT_INT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_INT_INT';

procedure GtkMarshal_NONE_POINTER_POINTER_UINT_UINT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_POINTER_INT_INT';

procedure GtkMarshal_NONE_POINTER_POINTER_INT_INT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_POINTER_INT_INT';

procedure GtkMarshal_NONE_POINTER_INT_INT_POINTER_UINT_UINT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_INT_INT_POINTER_INT_INT';

procedure GtkMarshal_NONE_POINTER_INT_INT_POINTER_INT_INT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_INT_INT_POINTER_INT_INT';

procedure GtkMarshal_NONE_POINTER_UINT_UINT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_INT_INT';

procedure GtkMarshal_NONE_STRING(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER';

procedure GtkMarshal_NONE_STRING_INT_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_INT_POINTER';

procedure GtkMarshal_NONE_POINTER_INT_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__POINTER_INT_POINTER';

procedure GtkMarshal_NONE_UINT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT';

procedure GtkMarshal_NONE_UINT_POINTER_UINT_ENUM_ENUM_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT_POINTER_INT_INT_INT_POINTER';

procedure GtkMarshal_NONE_INT_POINTER_INT_INT_INT_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT_POINTER_INT_INT_INT_POINTER';

procedure GtkMarshal_NONE_UINT_POINTER_UINT_UINT_ENUM(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT_POINTER_INT_INT_INT';

procedure GtkMarshal_NONE_INT_POINTER_INT_INT_INT(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT_POINTER_INT_INT_INT';

procedure GtkMarshal_NONE_UINT_STRING(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT_POINTER';

procedure GtkMarshal_NONE_INT_POINTER(OObject : PGtkObject; Func : TGtkSignalFunc; FuncData : GPointer; Args : PGtkArg);
asmname 'gtk_marshal_NONE__INT_POINTER';

implementation

end.
