{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program EventBox;

{$include "../units/gtk.inc"}
{$ignore-function-results}

var
  Window, EventBox, LLabel : PGtkWidget;

begin
  GtkInit;

  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkWindowSetTitle(PGtkWindow(Window), 'Event Box');
  GtkSignalConnect(PGtkObject(Window), 'destroy', @GtkExit, nil);
  GtkContainerSetBorderWidth(PGtkContainer(Window), 10);
    
  { Create an EventBox and add it to our toplevel window }
  EventBox := GtkEventBoxNew;
  GtkContainerAdd(PGtkContainer(Window), EventBox);
  GtkWidgetShow(EventBox);

  { Create a long label }
  LLabel := GtkLabelNew('Click here to quit, quit, quit, quit, quit');
  GtkContainerAdd(PGtkContainer(EventBox), LLabel);
  GtkWidgetShow(LLabel);

  { Clip it short. }
  GtkWidgetSetUSize(LLabel, 110, 20);

  { And bind an action to it }
  GtkWidgetSetEvents(EventBox, GDK_BUTTON_PRESS_MASK);
  GtkSignalConnect(PGtkObject(EventBox), 'button_press_event', @GtkExit, nil);

  { Yet one more thing you need an X window for ... }

  GtkWidgetRealize(EventBox);
  GdkWindowSetCursor(EventBox^.Window, GdkCursorNew(GDK_HAND1));

  GtkWidgetShow(Window);
  GtkMain;
end.
