{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program Frame;

{$include "../units/gtk.inc"}
{$ignore-function-results}

var
  { GtkWidget is the storage type for widgets }
  Window, Frame : PGtkWidget;

begin
  GtkInit;

  { Create a new window }
  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkWindowSetTitle(PGtkWindow(Window), 'Frame Example');

  { Here we connect the "destroy" event to a signal handler }
  GtkSignalConnect(PGtkObject(Window), 'destroy', @GtkMainQuit, nil);

  GtkWidgetSetUSize(Window, 300, 300);

  { Sets the border width of the window. }
  GtkContainerSetBorderWidth(PGtkContainer(Window), 10);

  { Create a Frame }
  Frame := GtkFrameNew(nil);
  GtkContainerAdd(PGtkContainer(Window), Frame);

  { Set the frame's label }
  GtkFrameSetLabel(PGtkFrame(Frame), 'GTK Frame Widget');

  { Align the label at the right of the frame }
  GtkFrameSetLabelAlign(PGtkFrame(Frame), 1.0, 0.0);

  { Set the style of the frame }
  GtkFrameSetShadowType(PGtkFrame(Frame), GTK_SHADOW_ETCHED_OUT);

  GtkWidgetShow(Frame);

  { Display the window }
  GtkWidgetShow(Window);

  { Enter the event loop }
  GtkMain;
end.
