{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program RadioButtons;

{$include "../units/gtk.inc"}
{$ignore-function-results}

function CloseApplication(Widget : PGtkWidget; Event : PGdkEvent; Data : GPointer) : GInt;
begin
  GtkMainQuit;
  CloseApplication := 0;
end;

var
  Window, Box1, Box2, Button, Separator : PGtkWidget;
  Group : PGSList;

begin
  GtkInit;

  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkSignalConnect(PGtkObject(Window), 'delete_event', @CloseApplication, nil);
  GtkWindowSetTitle(PGtkWindow(Window), 'radio buttons');
  GtkContainerSetBorderWidth(PGtkContainer(Window), 0);
  Box1 := GtkVBoxNew(G_FALSE, 0);
  GtkContainerAdd(PGtkContainer(Window), Box1);
  GtkWidgetShow(Box1);
  Box2 := GtkVBoxNew(G_FALSE, 10);
  GtkContainerSetBorderWidth(PGtkContainer(Box2), 10);
  GtkBoxPackStart(PGtkBox(Box1), Box2, G_TRUE, G_TRUE, 0);
  GtkWidgetShow(Box2);

  Button := GtkRadioButtonNewWithLabel(nil, 'button1');
  GtkBoxPackStart(PGtkBox(Box2), Button, G_TRUE, G_TRUE, 0);
  GtkWidgetShow(Button);

  Group := GtkRadioButtonGroup(PGtkRadioButton(Button));
  Button := GtkRadioButtonNewWithLabel(Group, 'button2');
  GtkToggleButtonSetActive(PGtkToggleButton(Button), G_TRUE);
  GtkBoxPackStart(PGtkBox(Box2), Button, G_TRUE, G_TRUE, 0);
  GtkWidgetShow(Button);

  Group := GtkRadioButtonGroup(PGtkRadioButton(Button));
  Button := GtkRadioButtonNewWithLabel(Group, 'button3');
  GtkBoxPackStart(PGtkBox(Box2), Button, G_TRUE, G_TRUE, 0);
  GtkWidgetShow(Button);

  Separator := GtkHSeparatorNew;
  GtkBoxPackStart(PGtkBox(Box1), Separator, G_FALSE, G_TRUE, 0);
  GtkWidgetShow(Separator);

  Box2 := GtkVBoxNew(G_FALSE, 10);
  GtkContainerSetBorderWidth(PGtkContainer(Box2), 10);
  GtkBoxPackStart(PGtkBox(Box1), Box2, G_FALSE, G_TRUE, 0);
  GtkWidgetShow(Box2);

  Button := GtkButtonNewWithLabel('close');
  GtkSignalConnectObject(PGtkObject(Button), 'clicked', @CloseApplication, PGtkObject(Window));
  GtkBoxPackStart(PGtkBox(Box2), Button, G_TRUE, G_TRUE, 0);
  GTK_WIDGET_SET_FLAGS(Button, GTK_CAN_DEFAULT);
  GtkWidgetGrabDefault(Button);
  GtkWidgetShow(Button);
  GtkWidgetShow(Window);

  GtkMain;
end.
